package com.s5gi.effect;

import net.minecraft.entity.attribute.EntityAttributeModifier;
import net.minecraft.entity.attribute.EntityAttributes;
import net.minecraft.entity.effect.StatusEffect;
import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.registry.RegistryKey;
import net.minecraft.util.Identifier;

import static com.s5gi.Lacess.MOD_ID;

public class LacessEffects {

    public static final RegistryKey<StatusEffect> CHORUS_EFFECT_KEY = RegistryKey.of(Registries.STATUS_EFFECT.getKey(), Identifier.of(MOD_ID, "chorus_effect"));


    public static final StatusEffect CHORUS_EFFECT = new Chorus_Effect()
            .addAttributeModifier(EntityAttributes.FALL_DAMAGE_MULTIPLIER, Identifier.of(MOD_ID, "chorus_effect"), -100, EntityAttributeModifier.Operation.ADD_VALUE);


    public static void init() {
        register(CHORUS_EFFECT_KEY, CHORUS_EFFECT);
    }

    public static StatusEffect register(RegistryKey<StatusEffect> registryKey, StatusEffect effect) {
        return Registry.register(Registries.STATUS_EFFECT, registryKey, effect);
    }

}
