package com.s5gi.item.behaviors;

import com.s5gi.effect.LacessEffects;
import com.s5gi.entity.LacessEntities;
import com.s5gi.networking.LacessNetworking;
import com.s5gi.networking.payloads.S2C.HudRendererTimeUpdatePayload;
import com.s5gi.sound.LacessSounds;
import net.fabricmc.fabric.api.itemgroup.v1.ItemGroupEvents;
import net.minecraft.entity.effect.StatusEffectInstance;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.item.Item;
import net.minecraft.item.ItemGroup;
import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.registry.RegistryKey;
import net.minecraft.registry.RegistryKeys;
import net.minecraft.sound.SoundCategory;
import net.minecraft.util.ActionResult;
import net.minecraft.util.Hand;
import net.minecraft.util.Identifier;
import net.minecraft.world.World;

import java.util.Random;

import static com.s5gi.Lacess.MOD_ID;

public class Chorus_Dust extends Item {
    public Chorus_Dust(Settings settings) {
        super(settings);
    }

    private final Random random = new Random();

    @Override
    public ActionResult use(World world, PlayerEntity user, Hand hand) {
        if (world.isClient) {
            return ActionResult.PASS;
        }


        if (!user.isInCreativeMode()) user.getStackInHand(hand).decrement(1);

        LacessNetworking.S2C.sendPayload(user.getServer().getPlayerManager().getPlayer(user.getUuid()), HudRendererTimeUpdatePayload.of(HudRendererTimeUpdatePayload.vars.CHORUS_DUST_OVERLAY, System.currentTimeMillis()));
        world.getServer().getWorld(world.getRegistryKey()).spawnParticles(LacessEntities.CHORUS_PARTICLE, user.getX() , user.getY() , user.getZ(), 25, 1, 1, 1, 0.15);
        world.playSound(null, user.getX(), user.getY(), user.getZ(), LacessSounds.CHORUS_DUST_INGEST_SOUND, SoundCategory.PLAYERS, 0.1f, random.nextFloat(0.5f, 2f));

        user.addStatusEffect(new StatusEffectInstance(Registries.STATUS_EFFECT.getEntry(LacessEffects.CHORUS_EFFECT), 60, 0, true, false));


        return ActionResult.SUCCESS;
    }

    public static Item register(String name, RegistryKey<ItemGroup> itemGroup) {
        Identifier id = Identifier.of(MOD_ID, name);
        RegistryKey<Item> key = RegistryKey.of(RegistryKeys.ITEM, id);
        Item.Settings settings = new Item.Settings().registryKey(key);
        Item item = Registry.register(Registries.ITEM, key, new Chorus_Dust(settings));
        ItemGroupEvents.modifyEntriesEvent(itemGroup)
                .register((itemGroupa) -> itemGroupa.add(item));
        return item;
    }
}
